Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.core
Class ContainerBase

    java.lang.Object
      org.apache.catalina.util.LifecycleBase
          org.apache.catalina.util.LifecycleMBeanBase
              org.apache.catalina.core.ContainerBase

All Implemented Interfaces:
  MBeanRegistration, Container, Lifecycle

Direct Known Subclasses:
  StandardContext, StandardEngine, StandardHost, StandardWrapper

    public abstract class ContainerBase

extends LifecycleMBeanBase
implements Container

Abstract implementation of the Container interface, providing common functionality required by nearly every implementation. Classes extending this base class must implement `getInfo()`, and may implement a replacement for `invoke()`.

All subclasses of this abstract base class will include support for a Pipeline object that defines the processing to be performed for each request received by the `invoke()` method of this class, utilizing the "Chain of Responsibility" design pattern. A subclass should encapsulate its own processing functionality as a `Valve`, and configure this Valve into the pipeline by calling `setBasic()`.

This implementation fires property change events, per the JavaBeans design pattern, for changes in singleton properties. In addition, it fires the following `ContainerEvent` events to listeners who register themselves with `addContainerListener()`:

Type | Data | Description
--- | --- | ---
`addChild` | `Container` | Child container added to this Container.
`addValve` | `Valve` | Valve added to this Container.
`removeChild` | `Container` | Child container removed from this Container.
`removeValve` | `Valve` | Valve removed from this Container.
`start` | `null` | Container was started.
`stop` | `null` | Container was stopped.

Subclasses that fire additional events should document them in the class comments of the implementation class. TODO: Review synchronisation around background processing. See bug 47024.

Author:
  Craig R. McClanahan

Nested Class Summary
`protected class` | `ContainerBase.ContainerBackgroundProcessor` Private thread class to invoke the backgroundProcess method of this container and its children after a fixed delay.
`protected class` | `ContainerBase.PrivilegedAddChild` Perform addChild with the permissions of this class.

Field Summary
`protected AccessLog` | `accessLog` The access log to use for requests normally handled by this container that have been handled earlier in the processing chain.
`protected int` | `backgroundProcessorDelay` The processor delay for this component.
`protected HashMap<String,Container>` | `children` The child Containers belonging to this Container, keyed by name.
`protected Cluster` | `cluster` The cluster with which this Container is associated.
`protected List<ContainerListener>` | `listeners` The container event listeners for this Container.
`protected Loader` | `loader` The Loader implementation with which this Container is associated.
`protected Log` | `logger` The Logger implementation with which this Container is associated.
`protected String` | `logName` Associated logger name.
`protected Manager` | `manager` The Manager implementation with which this Container is associated.
`protected String` | `name` The human-readable name of this Container.
`protected Container` | `parent` The parent Container to which this Container is a child.
`protected ClassLoader` | `parentClassLoader` The parent class loader to be configured when we install a Loader.
`protected Pipeline` | `pipeline` The Pipeline object with which this Container is associated.
`protected DirContext` | `resources` The resources DirContext object with which this Container is associated.
`protected static StringManager` | `sm` The string manager for this package.
`protected boolean` | `startChildren` Will children be started automatically when they are added.
`protected ThreadPoolExecutor` | `startStopExecutor`
`protected PropertyChangeSupport` | `support` The property change support for this component.

Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase
`mserver`

Fields inherited from interface org.apache.catalina.Container
`ADD_CHILD_EVENT, ADD_MAPPER_EVENT, ADD_VALVE_EVENT, REMOVE_CHILD_EVENT, REMOVE_MAPPER_EVENT, REMOVE_VALVE_EVENT`

Fields inherited from interface org.apache.catalina.Lifecycle
`AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

Constructor Summary
`ContainerBase()`

Method Summary
`void` | `addChild(Container child)` Add a new child Container to those associated with this Container, if supported.
`void` | `addContainerListener(ContainerListener listener)` Add a container event listener to this component.
`void` | `addPropertyChangeListener(PropertyChangeListener listener)` Add a property change listener to this component.
`void` | `addValve(Valve valve)` Convenience method, intended for use by the digester to simplify the process of adding Valves to containers.
`void` | `backgroundProcess()` Execute a periodic task, such as reloading, etc.
`protected void` | `destroyInternal()` Sub-classes wishing to perform additional clean-up should override this method, ensuring that super.destroyInternal() is the last call in the overriding method.
`Container` | `findChild(String name)` Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`
`Container[]` | `findChildren()` Return the set of children Containers associated with this Container.
`ContainerListener[]` | `findContainerListeners()` Return the set of container listeners associated with this Container.
`void` | `fireContainerEvent(String type, Object data)` Notify all container event listeners that a particular event has occurred for this Container.
`AccessLog` | `getAccessLog()` Identify the AccessLog to use to log a request/response that was destined for this container but was handled earlier in the processing chain so that the request/response still appears in the correct access logs.
`int` | `getBackgroundProcessorDelay()` Get the delay between the invocation of the backgroundProcess method on this container and its children.
`ObjectName[]` | `getChildren()`
`Cluster` | `getCluster()` Return the Cluster with which this Container is associated.
`protected String` | `getDomainInternal()` Method implemented by sub-classes to identify the domain in which MBeans should be registered.
`String` | `getInfo()` Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.
`Loader` | `getLoader()` Return the Loader with which this Container is associated.
`Log` | `getLogger()` Return the Logger for this Container.
`Manager` | `getManager()` Return the Manager with which this Container is associated.
`Object` | `getMappingObject()` Deprecated.
`String` | `getName()` Return a name string (suitable for use by humans) that describes this Container.
`Container` | `getParent()` Return the Container for which this Container is a child, if there is one.
`ClassLoader` | `getParentClassLoader()` Return the parent class loader (if any) for this web application.
`Pipeline` | `getPipeline()` Return the Pipeline object that manages the Valves associated with this Container.
`Realm` | `getRealm()` Return the Realm with which this Container is associated.
`protected Realm` | `getRealmInternal()`
`DirContext` | `getResources()` Return the resources DirContext object with which this Container is associated.
`boolean` | `getStartChildren()` Return if children of this container will be started automatically when they are added to this container.
`int` | `getStartStopThreads()` Returns the number of threads available for starting and stopping any children associated with this container.
`protected void` | `initInternal()` Sub-classes wishing to perform additional initialization should override this method, ensuring that super.initInternal() is the first call in the overriding method.
`void` | `invoke(Request request, Response response)` Process the specified Request, to produce the corresponding Response, by invoking the first Valve in our pipeline (if any), or the basic Valve otherwise.
`void` | `logAccess(Request request, Response response, long time, boolean useDefault)` Check this container for an access log and if none is found, look to the parent.
`protected String` | `logName()` Return the abbreviated name of this container for logging messages
`void` | `removeChild(Container child)` Remove an existing child Container from association with this parent Container.
`void` | `removeContainerListener(ContainerListener listener)` Remove a container event listener from this component.
`void` | `removePropertyChangeListener(PropertyChangeListener listener)` Remove a property change listener from this component.
`void` | `setBackgroundProcessorDelay(int delay)` Set the delay between the invocation of the execute method on this container and its children.
`void` | `setCluster(Cluster cluster)` Set the Cluster with which this Container is associated.
`void` | `setLoader(Loader loader)` Set the Loader with which this Container is associated.
`void` | `setManager(Manager manager)` Set the Manager with which this Container is associated.
`void` | `setName(String name)` Set a name string (suitable for use by humans) that describes this Container.
`void` | `setParent(Container container)` Set the parent Container to which this Container is being added as a child.
`void` | `setParentClassLoader(ClassLoader parent)` Set the parent class loader (if any) for this web application.
`void` | `setRealm(Realm realm)` Set the Realm with which this Container is associated.
`void` | `setResources(DirContext resources)` Set the resources DirContext object with which this Container is associated.
`void` | `setStartChildren(boolean startChildren)` Set if children of this container will be started automatically when they are added to this container.
`void` | `setStartStopThreads(int startStopThreads)` Sets the number of threads available for starting and stopping any children associated with this container.
`protected void` | `startInternal()` Start this component and implement the requirements of `LifecycleBase.startInternal()`.
`protected void` | `stopInternal()` Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.
`protected void` | `threadStart()` Start the background thread that will periodically check for session timeouts.
`protected void` | `threadStop()` Stop the background thread that is periodically checking for session timeouts.

Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase
`getDomain, getObjectName, getObjectNameKeyProperties, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister`

Methods inherited from class org.apache.catalina.util.LifecycleBase
`addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, init, removeLifecycleListener, setState, setState, start, stop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.catalina.Container
`getObjectName`

Methods inherited from interface org.apache.catalina.Lifecycle
`addLifecycleListener, destroy, findLifecycleListeners, getState, getStateName, init, removeLifecycleListener, start, stop`

Field Detail

### children

    protected HashMap<String,Container> children

  The child Containers belonging to this Container, keyed by name.

### backgroundProcessorDelay

    protected int backgroundProcessorDelay

  The processor delay for this component.

### listeners

    protected List<ContainerListener> listeners

  The container event listeners for this Container. Implemented as a CopyOnWriteArrayList since listeners may invoke methods to add/remove themselves or other listeners and with a ReadWriteLock that would trigger a deadlock.

### loader

    protected Loader loader

  The Loader implementation with which this Container is associated.

### logger

    protected Log logger

  The Logger implementation with which this Container is associated.

### logName

    protected String logName

  Associated logger name.

### manager

    protected Manager manager

  The Manager implementation with which this Container is associated.

### cluster

    protected Cluster cluster

  The cluster with which this Container is associated.

### name

    protected String name

  The human-readable name of this Container.

### parent

    protected Container parent

  The parent Container to which this Container is a child.

### parentClassLoader

    protected ClassLoader parentClassLoader

  The parent class loader to be configured when we install a Loader.

### pipeline

    protected Pipeline pipeline

  The Pipeline object with which this Container is associated.

### resources

    protected DirContext resources

  The resources DirContext object with which this Container is associated.

### sm

    protected static final StringManager sm

  The string manager for this package.

### startChildren

    protected boolean startChildren

  Will children be started automatically when they are added.

### support

    protected PropertyChangeSupport support

  The property change support for this component.

### accessLog

    protected volatile AccessLog accessLog

  The access log to use for requests normally handled by this container that have been handled earlier in the processing chain.

### startStopExecutor

    protected ThreadPoolExecutor startStopExecutor

Constructor Detail

### ContainerBase

    public ContainerBase()

Method Detail

### getStartStopThreads

    public int getStartStopThreads()

  Description copied from interface: `Container`
  Returns the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.

  Specified by:
    `getStartStopThreads` in interface `Container`

### setStartStopThreads

    public void setStartStopThreads(int startStopThreads)

  Description copied from interface: `Container`
  Sets the number of threads available for starting and stopping any children associated with this container. This allows start/stop calls to children to be processed in parallel.

  Specified by:
    `setStartStopThreads` in interface `Container`
  Parameters:
    `startStopThreads` - The new number of threads to be used

### getBackgroundProcessorDelay

    public int getBackgroundProcessorDelay()

  Get the delay between the invocation of the backgroundProcess method on this container and its children. Child containers will not be invoked if their delay value is not negative (which would mean they are using their own thread). Setting this to a positive value will cause a thread to be spawn. After waiting the specified amount of time, the thread will invoke the executePeriodic method on this container and all its children.

  Specified by:
    `getBackgroundProcessorDelay` in interface `Container`

### setBackgroundProcessorDelay

    public void setBackgroundProcessorDelay(int delay)

  Set the delay between the invocation of the execute method on this container and its children.

  Specified by:
    `setBackgroundProcessorDelay` in interface `Container`
  Parameters:
    `delay` - The delay in seconds between the invocation of backgroundProcess methods

### getInfo

    public String getInfo()

  Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.

  Specified by:
    `getInfo` in interface `Container`

### getLoader

    public Loader getLoader()

  Return the Loader with which this Container is associated. If there is no associated Loader, return the Loader associated with our parent Container (if any); otherwise, return `null`.

  Specified by:
    `getLoader` in interface `Container`

### setLoader

    public void setLoader(Loader loader)

  Set the Loader with which this Container is associated.

  Specified by:
    `setLoader` in interface `Container`
  Parameters:
    `loader` - The newly associated loader

### getLogger

    public Log getLogger()

  Return the Logger for this Container.

  Specified by:
    `getLogger` in interface `Container`

### getManager

    public Manager getManager()

  Return the Manager with which this Container is associated. If there is no associated Manager, return the Manager associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getManager` in interface `Container`

### setManager

    public void setManager(Manager manager)

  Set the Manager with which this Container is associated.

  Specified by:
    `setManager` in interface `Container`
  Parameters:
    `manager` - The newly associated Manager

### getMappingObject

    @Deprecated
    public Object getMappingObject()

  Deprecated.

  Return an object which may be utilized for mapping to this component.

  Specified by:
    `getMappingObject` in interface `Container`

### getCluster

    public Cluster getCluster()

  Return the Cluster with which this Container is associated. If there is no associated Cluster, return the Cluster associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getCluster` in interface `Container`

### setCluster

    public void setCluster(Cluster cluster)

  Set the Cluster with which this Container is associated.

  Specified by:
    `setCluster` in interface `Container`
  Parameters:
    `cluster` - The newly associated Cluster

### getName

    public String getName()

  Return a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

  Specified by:
    `getName` in interface `Container`

### setName

    public void setName(String name)

  Set a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

  Specified by:
    `setName` in interface `Container`
  Parameters:
    `name` - New name of this container
  Throws:
    `IllegalStateException` - if this Container has already been added to the children of a parent Container (after which the name may not be changed)

### getStartChildren

    public boolean getStartChildren()

  Return if children of this container will be started automatically when they are added to this container.

### setStartChildren

    public void setStartChildren(boolean startChildren)

  Set if children of this container will be started automatically when they are added to this container.

  Parameters:
    `startChildren` - New value of the startChildren flag

### getParent

    public Container getParent()

  Return the Container for which this Container is a child, if there is one. If there is no defined parent, return `null`.

  Specified by:
    `getParent` in interface `Container`

### setParent

    public void setParent(Container container)

  Set the parent Container to which this Container is being added as a child. This Container may refuse to become attached to the specified Container by throwing an exception.

  Specified by:
    `setParent` in interface `Container`
  Parameters:
    `container` - Container to which this Container is being added as a child
  Throws:
    `IllegalArgumentException` - if this Container refuses to become attached to the specified Container

### getParentClassLoader

    public ClassLoader getParentClassLoader()

  Return the parent class loader (if any) for this web application. This call is meaningful only after a Loader has been configured.

  Specified by:
    `getParentClassLoader` in interface `Container`

### setParentClassLoader

    public void setParentClassLoader(ClassLoader parent)

  Set the parent class loader (if any) for this web application. This call is meaningful only before a Loader has been configured, and the specified value (if non-null) should be passed as an argument to the class loader constructor.

  Specified by:
    `setParentClassLoader` in interface `Container`
  Parameters:
    `parent` - The new parent class loader

### getPipeline

    public Pipeline getPipeline()

  Return the Pipeline object that manages the Valves associated with this Container.

  Specified by:
    `getPipeline` in interface `Container`

### getRealm

    public Realm getRealm()

  Return the Realm with which this Container is associated. If there is no associated Realm, return the Realm associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getRealm` in interface `Container`

### getRealmInternal

    protected Realm getRealmInternal()

### setRealm

    public void setRealm(Realm realm)

  Set the Realm with which this Container is associated.

  Specified by:
    `setRealm` in interface `Container`
  Parameters:
    `realm` - The newly associated Realm

### getResources

    public DirContext getResources()

  Return the resources DirContext object with which this Container is associated. If there is no associated resources object, return the resources associated with our parent Container (if any); otherwise return `null`.

  Specified by:
    `getResources` in interface `Container`

### setResources

    public void setResources(DirContext resources)

  Set the resources DirContext object with which this Container is associated.

  Specified by:
    `setResources` in interface `Container`
  Parameters:
    `resources` - The newly associated DirContext

### addChild

    public void addChild(Container child)

  Add a new child Container to those associated with this Container, if supported. Prior to adding this Container to the set of children, the child's `setParent()` method must be called, with this Container as an argument. This method may thrown an `IllegalArgumentException` if this Container chooses not to be attached to the specified Container, in which case it is not added

  Specified by:
    `addChild` in interface `Container`
  Parameters:
    `child` - New child Container to be added
  Throws:
    `IllegalArgumentException` - if this exception is thrown by the `setParent()` method of the child Container
    `IllegalArgumentException` - if the new child does not have a name unique from that of existing children of this Container
    `IllegalStateException` - if this Container does not support child Containers

### addContainerListener

    public void addContainerListener(ContainerListener listener)

  Add a container event listener to this component.

  Specified by:
    `addContainerListener` in interface `Container`
  Parameters:
    `listener` - The listener to add

### addPropertyChangeListener

    public void addPropertyChangeListener(PropertyChangeListener listener)

  Add a property change listener to this component.

  Specified by:
    `addPropertyChangeListener` in interface `Container`
  Parameters:
    `listener` - The listener to add

### findChild

    public Container findChild(String name)

  Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`

  Specified by:
    `findChild` in interface `Container`
  Parameters:
    `name` - Name of the child Container to be retrieved

### findChildren

    public Container[] findChildren()

  Return the set of children Containers associated with this Container. If this Container has no children, a zero-length array is returned.

  Specified by:
    `findChildren` in interface `Container`

### findContainerListeners

    public ContainerListener[] findContainerListeners()

  Return the set of container listeners associated with this Container. If this Container has no registered container listeners, a zero-length array is returned.

  Specified by:
    `findContainerListeners` in interface `Container`

### invoke

    public void invoke(Request request,
                       Response response)
                throws IOException,
                       ServletException

  Process the specified Request, to produce the corresponding Response, by invoking the first Valve in our pipeline (if any), or the basic Valve otherwise.

  Specified by:
    `invoke` in interface `Container`
  Parameters:
    `request` - Request to be processed
    `response` - Response to be produced
  Throws:
    `IllegalStateException` - if neither a pipeline or a basic Valve have been configured for this Container
    `IOException` - if an input/output error occurred while processing
    `ServletException` - if a ServletException was thrown while processing this request

### removeChild

    public void removeChild(Container child)

  Remove an existing child Container from association with this parent Container.

  Specified by:
    `removeChild` in interface `Container`
  Parameters:
    `child` - Existing child Container to be removed

### removeContainerListener

    public void removeContainerListener(ContainerListener listener)

  Remove a container event listener from this component.

  Specified by:
    `removeContainerListener` in interface `Container`
  Parameters:
    `listener` - The listener to remove

### removePropertyChangeListener

    public void removePropertyChangeListener(PropertyChangeListener listener)

  Remove a property change listener from this component.

  Specified by:
    `removePropertyChangeListener` in interface `Container`
  Parameters:
    `listener` - The listener to remove

### initInternal

    protected void initInternal()
                         throws LifecycleException

  Description copied from class: `LifecycleMBeanBase`
  Sub-classes wishing to perform additional initialization should override this method, ensuring that super.initInternal() is the first call in the overriding method.

  Overrides:
    `initInternal` in class `LifecycleMBeanBase`
  Throws:
    `LifecycleException`

### startInternal

    protected void startInternal()
                          throws LifecycleException

  Start this component and implement the requirements of `LifecycleBase.startInternal()`.

  Specified by:
    `startInternal` in class `LifecycleBase`
  Throws:
    `LifecycleException` - if this component detects a fatal error that prevents this component from being used

### stopInternal

    protected void stopInternal()
                         throws LifecycleException

  Stop this component and implement the requirements of `LifecycleBase.stopInternal()`.

  Specified by:
    `stopInternal` in class `LifecycleBase`
  Throws:
    `LifecycleException` - if this component detects a fatal error that prevents this component from being used

### destroyInternal

    protected void destroyInternal()
                            throws LifecycleException

  Description copied from class: `LifecycleMBeanBase`
  Sub-classes wishing to perform additional clean-up should override this method, ensuring that super.destroyInternal() is the last call in the overriding method.

  Overrides:
    `destroyInternal` in class `LifecycleMBeanBase`
  Throws:
    `LifecycleException`

### logAccess

    public void logAccess(Request request,
                          Response response,
                          long time,
                          boolean useDefault)

  Check this container for an access log and if none is found, look to the parent. If there is no parent and still none is found, use the NoOp access log.

  Specified by:
    `logAccess` in interface `Container`
  Parameters:
    `request` - Request (associated with the response) to log
    `response` - Response (associated with the request) to log
    `time` - Time taken to process the request/response in milliseconds (use 0 if not known)
    `useDefault` - Flag that indicates that the request/response should be logged in the engine's default access log

### getAccessLog

    public AccessLog getAccessLog()

  Description copied from interface: `Container`
  Identify the AccessLog to use to log a request/response that was destined for this container but was handled earlier in the processing chain so that the request/response still appears in the correct access logs.

  Specified by:
    `getAccessLog` in interface `Container`

### addValve

    public void addValve(Valve valve)

  Convenience method, intended for use by the digester to simplify the process of adding Valves to containers. See `Pipeline.addValve(Valve)` for full details. Components other than the digester should use `getPipeline()`.`addValve(Valve)` in case a future implementation provides an alternative method for the digester to use.

  Parameters:
    `valve` - Valve to be added
  Throws:
    `IllegalArgumentException` - if this Container refused to accept the specified Valve
    `IllegalArgumentException` - if the specified Valve refuses to be associated with this Container
    `IllegalStateException` - if the specified Valve is already associated with a different Container

### backgroundProcess

    public void backgroundProcess()

  Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

  Specified by:
    `backgroundProcess` in interface `Container`

### fireContainerEvent

    public void fireContainerEvent(String type,
                                   Object data)

  Notify all container event listeners that a particular event has occurred for this Container. The default implementation performs this notification synchronously using the calling thread.

  Specified by:
    `fireContainerEvent` in interface `Container`
  Parameters:
    `type` - Event type
    `data` - Event data

### logName

    protected String logName()

  Return the abbreviated name of this container for logging messages

### getDomainInternal

    protected String getDomainInternal()

  Description copied from class: `LifecycleMBeanBase`
  Method implemented by sub-classes to identify the domain in which MBeans should be registered.

  Specified by:
    `getDomainInternal` in class `LifecycleMBeanBase`
  Returns:
    The name of the domain to use to register MBeans.

### getChildren

    public ObjectName[] getChildren()

### threadStart

    protected void threadStart()

  Start the background thread that will periodically check for session timeouts.

### threadStop

    protected void threadStop()

  Stop the background thread that is periodically checking for session timeouts.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2012 Apache Software Foundation. All Rights Reserved.